#define _arch_dreamcast

#include <kos.h>

#define BUFFER_WIDTH 	512	
#define BUFFER_HEIGHT 	256
#define FONT_WIDTH 		8
#define FONT_HEIGHT 	8
////#define DISPLAY_WIDTH 	512
////#define DISPLAY_HEIGHT 	256
#define DISPLAY_WIDTH 	320
#define DISPLAY_HEIGHT 	240
//#define BORDER_LEFT 	(BUFFER_WIDTH-DISPLAY_WIDTH)/2
//#define BORDER_TOP 	(BUFFER_HEIGHT-DISPLAY_HEIGHT)/2
#define BORDER_LEFT 	32
#define BORDER_TOP 		32
#define NUM_OPTIONS	19
#define INI_FILE		"gp:\\GPMM\\SPECCYAL.INI"

// Options types and states

#define	OPT_TYPE_ON_OFF	0	// "on/off" style option
#define	OPT_TYPE_CHECKBOX	1	// checkbox style (only one option selected at a given time inside a group)
#define	OPT_TYPE_COMMENT	2	// this is skipped by draw_options
#define	OPT_TYPE_KEY	3	// Bind a joystick button to a virtual keyboard key

#define	OPT_STATE_OFF	0	// unchecked
#define	OPT_STATE_ON	1	// checked

#define KEY_ASSERTED		(1)
#define	KEY_RELEASED		(2)
#define	KEY_PUSHED			(3)
#define	KEY_DELAY			(10)


// starting Y position of the options menu

#define 	START_Y		4

struct opt
{
	char type; // 0 = on/off, 1 = checkbox, 2 = comment, 3 = key
	signed char group; // options with the same number are grouped and only one these options can be checked at a given time
	char *opt_text; // option text
	int xpos, ypos; // expressed in characters, not pixels
	int state; // 0 = not selected (or "off" if type is OPT_TYPE_ON_OFF), 1 = selected (or "on"), or equal to a key char if type=3
	int opt_num; // see enum below
	int page; // menu page number
	int disabled; // option is disabled ???
};

enum { 
	MACHINE48K, MACHINE128K, SINCLAIR1, SINCLAIR2, CURSOR, BORDER, FPS, RENDERING, 
	CUSTOM_KEYS, KEY_UP, KEY_DOWN, KEY_LEFT, KEY_RIGHT, KEY_FIREA, KEY_FIREB, FRAMESKIP, FILTERING, FULLSCREEN
};

extern unsigned char charrom[];

int ascii2charrom(char chr);
void text_out8(uint16 *screen, const char *string, unsigned char bg, unsigned char fg, 
		int x, int y, int transparant);
void text_out8b (uint16 *screen, const char *string, unsigned char bg, unsigned char fg, 
		int x, int y, int transparant);
void text_out8c (uint16 *screen, const char *string, unsigned char bg, unsigned char fg, 
		int x, int y, int transparant);
int draw_options(int bg, int fg, int sel_color);
int get_option_state (int opt_num);
void set_option_state (int opt_num, int state);
int save_options (void);
int load_options (void);
int save_game_keys (char *game_filename);
int load_game_keys (char *game_filename);
char display_virtual_keyboard2 (int bg, int fg);
void RectFill (uint16 *screen, unsigned int x, unsigned int y, unsigned int w, unsigned int h, unsigned int bg);
void RectDraw (uint16 *screen, unsigned int x, unsigned int y, unsigned int w, unsigned int h, unsigned int fg);
void BitBlt (uint16 *screen, unsigned int dx, unsigned int dy, unsigned int dw, unsigned int dh, unsigned char *src,
			 unsigned int sx, unsigned int sy, unsigned int sw, unsigned int sh);
void Delay (long delay);
void displayMenuOptions (int bg, int fg, int sel_color);
void clearBackground (int bg);
uint16 check_buttons(uint16 keyvalue,uint16 keymask);
void displayRectangle (int nflip, int cur_col, int cur_row, int color);
void drawKeyboard (void);
void drawBackground (void);
void display_pressed_key_and_flip (int nflip, int cur_col, int cur_row);
void fill_border (int nflip, int k_status);
void write_vms_header (file_t f, int bKeyFile);